#ifndef _DECL_CentralLB_H_
#define _DECL_CentralLB_H_
#include "charm++.h"
#include "BaseLB.decl.h"

#include "LBDatabase.decl.h"

#include "CentralLBMsg.h"

/* DECLS: readonly CkGroupID loadbalancer;
 */


/* DECLS: group CentralLB: BaseLB{
CentralLB(CkMigrateMessage* impl_msg);
void CentralLB(const CkLBOptions &impl_noname_0);
void ProcessAtSync(void);
void SendStats(void);
void ReceiveStats(const CkMarshalledCLBStatsMessage &data);
void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data);
void ReceiveCounts(CkReductionMsg* impl_msg);
void LoadBalance(void);
void ResumeClients(int impl_noname_1);
void ResumeClients(CkReductionMsg* impl_msg);
void ReceiveMigration(LBMigrateMsg* impl_msg);
void MissMigrate(int impl_noname_2);
};
 */
 class CentralLB;
 class CkIndex_CentralLB;
 class CProxy_CentralLB;
 class CProxyElement_CentralLB;
/* --------------- index object ------------------ */
class CkIndex_CentralLB:public CProxyElement_BaseLB{
  public:
    typedef CentralLB local_t;
    typedef CkIndex_CentralLB index_t;
    typedef CProxy_CentralLB proxy_t;
    typedef CProxyElement_CentralLB element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: CentralLB(CkMigrateMessage* impl_msg);
 */
    static int __idx_CentralLB_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_CentralLB_CkMigrateMessage; }
    static void _call_CentralLB_CkMigrateMessage(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void CentralLB(const CkLBOptions &impl_noname_0);
 */
    static int __idx_CentralLB_marshall1;
    static int ckNew(const CkLBOptions &impl_noname_0) { return __idx_CentralLB_marshall1; }
    static void _call_CentralLB_marshall1(void* impl_msg,CentralLB* impl_obj);
    static int _callmarshall_CentralLB_marshall1(char* impl_buf,CentralLB* impl_obj);
    static void _marshallmessagepup_CentralLB_marshall1(PUP::er &p,void *msg);

/* DECLS: void ProcessAtSync(void);
 */
    static int __idx_ProcessAtSync_void;
    static int ProcessAtSync(void) { return __idx_ProcessAtSync_void; }
    static void _call_ProcessAtSync_void(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void SendStats(void);
 */
    static int __idx_SendStats_void;
    static int SendStats(void) { return __idx_SendStats_void; }
    static void _call_SendStats_void(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void ReceiveStats(const CkMarshalledCLBStatsMessage &data);
 */
    static int __idx_ReceiveStats_marshall4;
    static int ReceiveStats(const CkMarshalledCLBStatsMessage &data) { return __idx_ReceiveStats_marshall4; }
    static void _call_ReceiveStats_marshall4(void* impl_msg,CentralLB* impl_obj);
    static int _callmarshall_ReceiveStats_marshall4(char* impl_buf,CentralLB* impl_obj);
    static void _marshallmessagepup_ReceiveStats_marshall4(PUP::er &p,void *msg);

/* DECLS: void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data);
 */
    static int __idx_ReceiveStatsViaTree_marshall5;
    static int ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data) { return __idx_ReceiveStatsViaTree_marshall5; }
    static void _call_ReceiveStatsViaTree_marshall5(void* impl_msg,CentralLB* impl_obj);
    static int _callmarshall_ReceiveStatsViaTree_marshall5(char* impl_buf,CentralLB* impl_obj);
    static void _marshallmessagepup_ReceiveStatsViaTree_marshall5(PUP::er &p,void *msg);

/* DECLS: void ReceiveCounts(CkReductionMsg* impl_msg);
 */
    static int __idx_ReceiveCounts_CkReductionMsg;
    static int ReceiveCounts(CkReductionMsg* impl_msg) { return __idx_ReceiveCounts_CkReductionMsg; }
    static void _call_ReceiveCounts_CkReductionMsg(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void LoadBalance(void);
 */
    static int __idx_LoadBalance_void;
    static int LoadBalance(void) { return __idx_LoadBalance_void; }
    static void _call_LoadBalance_void(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void ResumeClients(int impl_noname_1);
 */
    static int __idx_ResumeClients_marshall8;
    static int ResumeClients(int impl_noname_1) { return __idx_ResumeClients_marshall8; }
    static void _call_ResumeClients_marshall8(void* impl_msg,CentralLB* impl_obj);
    static int _callmarshall_ResumeClients_marshall8(char* impl_buf,CentralLB* impl_obj);
    static void _marshallmessagepup_ResumeClients_marshall8(PUP::er &p,void *msg);

/* DECLS: void ResumeClients(CkReductionMsg* impl_msg);
 */
    static int __idx_ResumeClients_CkReductionMsg;
    static int ResumeClients(CkReductionMsg* impl_msg) { return __idx_ResumeClients_CkReductionMsg; }
    static void _call_ResumeClients_CkReductionMsg(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    static int __idx_ReceiveMigration_LBMigrateMsg;
    static int ReceiveMigration(LBMigrateMsg* impl_msg) { return __idx_ReceiveMigration_LBMigrateMsg; }
    static void _call_ReceiveMigration_LBMigrateMsg(void* impl_msg,CentralLB* impl_obj);

/* DECLS: void MissMigrate(int impl_noname_2);
 */
    static int __idx_MissMigrate_marshall11;
    static int MissMigrate(int impl_noname_2) { return __idx_MissMigrate_marshall11; }
    static void _call_MissMigrate_marshall11(void* impl_msg,CentralLB* impl_obj);
    static int _callmarshall_MissMigrate_marshall11(char* impl_buf,CentralLB* impl_obj);
    static void _marshallmessagepup_MissMigrate_marshall11(PUP::er &p,void *msg);
};
/* --------------- element proxy ------------------ */
class CProxyElement_CentralLB: public CProxyElement_BaseLB{
  public:
    typedef CentralLB local_t;
    typedef CkIndex_CentralLB index_t;
    typedef CProxy_CentralLB proxy_t;
    typedef CProxyElement_CentralLB element_t;

    CProxyElement_CentralLB(void) {}
    CProxyElement_CentralLB(const IrrGroup *g) : CProxyElement_BaseLB(g){  }
    CProxyElement_CentralLB(CkGroupID _gid,int _onPE,CK_DELCTOR_PARAM) : CProxyElement_BaseLB(_gid,_onPE,CK_DELCTOR_ARGS){  }
    CProxyElement_CentralLB(CkGroupID _gid,int _onPE) : CProxyElement_BaseLB(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_BaseLB)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_BaseLB::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_BaseLB::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_BaseLB::ckSetGroupID(g);
    }
    CentralLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static CentralLB* ckLocalBranch(CkGroupID gID) {
      return (CentralLB*)CkLocalBranch(gID);
    }
/* DECLS: CentralLB(CkMigrateMessage* impl_msg);
 */

/* DECLS: void CentralLB(const CkLBOptions &impl_noname_0);
 */

/* DECLS: void ProcessAtSync(void);
 */
    void ProcessAtSync(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void SendStats(void);
 */
    void SendStats(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ReceiveStats(const CkMarshalledCLBStatsMessage &data);
 */
    void ReceiveStats(const CkMarshalledCLBStatsMessage &data, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data);
 */
    void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ReceiveCounts(CkReductionMsg* impl_msg);
 */
    void ReceiveCounts(CkReductionMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void LoadBalance(void);
 */
    void LoadBalance(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ResumeClients(int impl_noname_1);
 */
    void ResumeClients(int impl_noname_1, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: int impl_noname_1
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_1;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_1;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ResumeClients(CkReductionMsg* impl_msg);
 */
    void ResumeClients(CkReductionMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    void ReceiveMigration(LBMigrateMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }

/* DECLS: void MissMigrate(int impl_noname_2);
 */
    void MissMigrate(int impl_noname_2, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: int impl_noname_2
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_2;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_2;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(ckDelegatedPtr(),CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupPe(), ckGetGroupID(),0);
    }
};
PUPmarshall(CProxyElement_CentralLB);
/* ---------------- collective proxy -------------- */
class CProxy_CentralLB: public CProxy_BaseLB{
  public:
    typedef CentralLB local_t;
    typedef CkIndex_CentralLB index_t;
    typedef CProxy_CentralLB proxy_t;
    typedef CProxyElement_CentralLB element_t;

    CProxy_CentralLB(void) {}
    CProxy_CentralLB(const IrrGroup *g) : CProxy_BaseLB(g){  }
    CProxy_CentralLB(CkGroupID _gid,CK_DELCTOR_PARAM) : CProxy_BaseLB(_gid,CK_DELCTOR_ARGS){  }
    CProxy_CentralLB(CkGroupID _gid) : CProxy_BaseLB(_gid){  }
    CProxyElement_CentralLB operator[](int onPE) const
      {return CProxyElement_CentralLB(ckGetGroupID(),onPE,CK_DELCTOR_CALL);}
   CK_DISAMBIG_GROUP(CProxy_BaseLB)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_BaseLB::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_BaseLB::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_BaseLB::ckSetGroupID(g);
    }
    CentralLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static CentralLB* ckLocalBranch(CkGroupID gID) {
      return (CentralLB*)CkLocalBranch(gID);
    }
/* DECLS: CentralLB(CkMigrateMessage* impl_msg);
 */

/* DECLS: void CentralLB(const CkLBOptions &impl_noname_0);
 */
    static CkGroupID ckNew(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_CentralLB(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ProcessAtSync(void);
 */
    void ProcessAtSync(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, ckGetGroupID(),0);
    }
    void ProcessAtSync(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ProcessAtSync_void, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void SendStats(void);
 */
    void SendStats(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_SendStats_void, impl_msg, ckGetGroupID(),0);
    }
    void SendStats(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_SendStats_void, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ReceiveStats(const CkMarshalledCLBStatsMessage &data);
 */
    void ReceiveStats(const CkMarshalledCLBStatsMessage &data, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, ckGetGroupID(),0);
    }
    void ReceiveStats(const CkMarshalledCLBStatsMessage &data, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL)
    {
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ReceiveStats_marshall4, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data);
 */
    void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, ckGetGroupID(),0);
    }
    void ReceiveStatsViaTree(const CkMarshalledCLBStatsMessage &data, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL)
    {
  //Marshall: const CkMarshalledCLBStatsMessage &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkMarshalledCLBStatsMessage &)data;
  }
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ReceiveStatsViaTree_marshall5, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ReceiveCounts(CkReductionMsg* impl_msg);
 */
    void ReceiveCounts(CkReductionMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, ckGetGroupID(),0);
    }
    void ReceiveCounts(CkReductionMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ReceiveCounts_CkReductionMsg, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void LoadBalance(void);
 */
    void LoadBalance(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, ckGetGroupID(),0);
    }
    void LoadBalance(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_LoadBalance_void, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ResumeClients(int impl_noname_1);
 */
    void ResumeClients(int impl_noname_1, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: int impl_noname_1
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_1;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_1;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, ckGetGroupID(),0);
    }
    void ResumeClients(int impl_noname_1, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL)
    {
  //Marshall: int impl_noname_1
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_1;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_1;
  }
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ResumeClients_marshall8, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ResumeClients(CkReductionMsg* impl_msg);
 */
    void ResumeClients(CkReductionMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, ckGetGroupID(),0);
    }
    void ResumeClients(CkReductionMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ResumeClients_CkReductionMsg, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    void ReceiveMigration(LBMigrateMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID(),0);
    }
    void ReceiveMigration(LBMigrateMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, npes, pes, ckGetGroupID(),0);
    }

/* DECLS: void MissMigrate(int impl_noname_2);
 */
    void MissMigrate(int impl_noname_2, const CkEntryOptions *impl_e_opts=NULL)
    {
    ckCheck();
  //Marshall: int impl_noname_2
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_2;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_2;
  }
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(ckDelegatedPtr(),CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, ckGetGroupID(),0);
    }
    void MissMigrate(int impl_noname_2, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL)
    {
  //Marshall: int impl_noname_2
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|impl_noname_2;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|impl_noname_2;
  }
      CkSendMsgBranchMulti(CkIndex_CentralLB::__idx_MissMigrate_marshall11, impl_msg, npes, pes, ckGetGroupID(),0);
    }
};
PUPmarshall(CProxy_CentralLB);
typedef CBaseT<BaseLB,CProxy_CentralLB>  CBase_CentralLB;

extern void _registerCentralLB(void);
#endif
